<template>
  <div>
    <ConfirmDialog ref="confirmationDialog" i18n="test" />

    <!-- The whole tool is located in this component -->
    <Tool ref="tool" />

    <v-snackbar
      v-model="nonProductionWarningSnackbar"
      color="warning"
      multi-line
      :timeout="-1"
      max-width="500"
    >
      {{ $t("tool.nonProductionWarning") }}
      <v-btn dark text @click="closeNonProductionWarningSnackbar()">
        {{ $t("tool.navigation.close") }}
      </v-btn>
    </v-snackbar>
  </div>
</template>

<script>
import Tool from "../components/App/Tool";
import ConfirmDialog from "../components/App/Form/Dialog/ConfirmDialog";

export default {
  name: "Index",
  components: { ConfirmDialog, Tool },
  beforeRouteLeave(_to, _from, next) {
    if (this.redirect) {
      next();
    } else {
      const answer = this.$refs.tool.beforeRouteLeave();
      if (!answer) {
        next(false);
      } else {
        next();
      }
    }
  },
  layout: "OnlyApp",
  data() {
    return {
      redirect: false,
      nonProductionWarningSnackbar: false,
    };
  },
  mounted() {
    this.$global.$refs.confirmationDialog = this.$refs.confirmationDialog;

    // redirect to correct locale
    const locale = this.$warehouse.get("locale");
    if (locale && this.$i18n.locale !== locale) {
      this.$logger.info(`Redirecting from ${this.$i18n.locale} to ${locale}`);
      this.$logger.info(this.switchLocalePath(locale));

      this.redirect = true;
      this.$global.$emit("beforeLocaleRedirect", locale);
      this.$nuxt.$router.replace({ path: this.gSwitchLocalePath(locale) });

      return;
    }

    // check if nonProductionWarningSnackbar was REALLY closed once
    if (this.$warehouse.get("nonProductionWarningSnackbar") !== false) {
      this.nonProductionWarningSnackbar = true;
    }
  },
  methods: {
    closeNonProductionWarningSnackbar() {
      this.nonProductionWarningSnackbar = false;
      this.$warehouse.set("nonProductionWarningSnackbar", false);
    },
  },
};
</script>
